#!/usr/bin/perl -Tw

# takes an lav file and produces either SVG, png, or pdf output.

$ENV{PATH} = "/usr/bin";

use strict;

use LWP::Simple;
use CGI::Carp qw(fatalsToBrowser carpout warningsToBrowser);
use CGI qw(header param);

sub BEGIN {
 my $DOC_ROOT=$ENV{DOCUMENT_ROOT};
# my $DEF_ROOT = "/export/home/www";		# sun3
 my $DEF_ROOT = "/Library/WebServer/Documents";
 $DOC_ROOT = $DEF_ROOT unless($DOC_ROOT);
 my $OK_CHARS='\"\+\-a-zA-Z0-9_.@ \/%:';
 $DOC_ROOT =~ s/[^$OK_CHARS]/_/go;
 ($DOC_ROOT) = $DOC_ROOT =~ m/^\s*(.*)/;  # de-taint and remove leading spaces
 my @TMP_ROOTL = split(/\//,$DOC_ROOT);
 my $TMP_ROOT = "/".join("/",@TMP_ROOTL[1 .. ($#TMP_ROOTL-1)])."/tmp";
# my $TMP_ROOT = "/tmp/www";
 open(LOG, ">> $TMP_ROOT/logs/errors.log") or die $!;
 carpout(\*LOG);
}

use vars qw( $OK_CHARS $HOST_NAME $HOST_DIR $CGI_DIR $BIN_DIR
	     $TMP_DIR $GS_BIN $DEF_UNLINK $LAV_SVG $LAV_GS $lav_cmd
	     $PPM_BIN $LOG_FILE $lhost
	     $file $device $tmp_lav $size $z_param);

require "./fawww_defs.pl";


$LAV_SVG = "$BIN_DIR/lav2svg";
$LAV_GS = "$BIN_DIR/lav2ps";

$file = param("name") || "";
$file =~ s/[;><&\*`\|\s]//g;

if ($file =~ /^([\w\.]+)$/) {
  $tmp_lav = $1;                     # $data now untainted
}

$size = param("size") || "";
if ($size) { 
  $size =~ s/[^$OK_CHARS]/_/go;
  if ($size =~ /^(\d+x\d+)$/) {
    $size = "-g".$1;                     # $data now untainted
  }
  else { $size = "";}
}

if (param("Z")) {
    $z_param = get_safe_number("-Z", param("Z"));
}
else {$z_param = "";}

$device = param("dev");
if ($device =~ m/pdf/) {
    $device = "pdfwrite";
    print header(-type=>'application/pdf');
}
elsif ($device =~ m/svg/i) {
    $device = "svg";
    print header(-type=>'image/svg+xml',
		 'Content-Disposition'=>"filename=lalign.svg");
}
else {
    $device = "png256";
    print header(-type=>'image/png');
}

$|  = 1;

# print STDERR "tmp_lav: $tmp_lav\n";

if ($tmp_lav) {
  $tmp_lav = "$TMP_DIR/$tmp_lav";
  if ($device eq 'svg') {
    $lav_cmd = "$LAV_SVG $z_param < $tmp_lav" ;
  }
  else {
    $lav_cmd = "$LAV_GS $z_param < $tmp_lav | $GS_BIN -q $size -dNOPAUSE -sDEVICE=$device -sOutputFile=- -";
  }

  system("$lav_cmd");

  if (param("del") && (param("del") eq "yes")) {unlink "$tmp_lav";}
  exit(0);
}
else {
  die(" tmp_lav.cgi - no file to process");
}


sub get_safe_number {
  my ($opt, $p_arg) = @_;
  
  unless ($p_arg) {return "";}

  if ($p_arg =~ m/DEFAULT/i) {return "";}

  ($p_arg) = ($p_arg =~ m/([E\d\-\.]+)/i);
  unless ($p_arg) {return "";}

  return "$opt $p_arg";
}
